program connection_mem_leak_test
    use connection_m
    use neuron_m
    use normal_m
    use data_kinds_4neuro_m

    type(mock_neuron_t), target  :: n1, n2
    class(neuron_t), pointer :: n1_p, n2_p
    class(connection_t), allocatable :: n_t
    type(connection_t)           :: con1, con2

    print *, '+---------------------------------------------------------+'
    print *, '| STARTING MEMORY LEAK TESTING OF THE MODULE CONNECTION_M |'
    print *, '+---------------------------------------------------------+'

    print *, 'Creating instances of the class neuron_t...'
    n1 = mock_neuron_t()
    n2 = mock_neuron_t()

    n1_p => n1
    n2_p => n2

    print *, 'Creating an instance of the class interval_connection_t with 2-parameters constructor...'
    con2 = connection_t(input_neuron=n1_p, output_neuron=n2_p)

    print *, 'Creating an instance of the class interval_connection_t with 3-parameters constructor...'
    con1 = connection_t(input_neuron=n1_p, output_neuron=n2_p, weight=real(5.25, real_4neuro))

    open(123,file='connection.test', form='unformatted')
        write(123) con1
    close(123)

    !open(123,file='connection.test', form='unformatted')
    !    read(123) n_t
    !close(123)

end program connection_mem_leak_test
